<?php

function prv_frequentPorts() {

	if (!getVar("num")) setVar("num", 50);
	if (!getVar("type")) setVar("type", 1);
	if (!getVar("direction")) setVar("direction", 1);
	if (!getVar("protocol")) setVar("protocol", 6);

	$_ENV['contentTitle'] = "Frequent Ports";

	$_ENV['templateData'] = frequentPortsData();

	$_ENV['template'] = "template_frequentPorts.php";

}

function frequentPortsData() {

	$num = sanitize("num");
	if (!$num) $num = 50;
		
	$type = sanitize("type");
	if (!$type) $type = 1;

	$direction = sanitize("direction");
	if (!$direction) $direction = 1;

	$protocol = sanitize("protocol");
	if (!$protocol) $protocol = 6;

	$type == 1 ? $order = "DESC" : $order = "ASC";
	$direction == 1 ? $direction = "sport" : $direction = "dport";

	$dateTimeRange = sanitize("dateTimeRange");

	$chartArray = array();
	$resultArray = array();

	$total = 0;
	$otherCount = 0;

	$dateQuery = "";
	$errorText = "";
	
	if ($dateTimeRange && $dateTimeRange != "all") {
	
		$currentTimeArray = getdate(consoleTimeConversion(time()));
	
		switch ($dateTimeRange) {
	
			case "selectRange":
	
				if (sanitize('startAMPM') == "PM")
					$startHourAdd = 12;
				else
					$startHourAdd = 0;
	
				if (sanitize('endAMPM') == "PM")
					$endHourAdd = 12;
				else
					$endHourAdd = 0;
	
				if (!checkdate(sanitize('startMonth'),sanitize('startDate'),sanitize('startYear')) || !checkdate(sanitize('endMonth'),sanitize('endDate'),sanitize('endYear')))
					$errorText = "<span style=\"color:red; font-size: 16px;\">INVALID DATE ENTERED</span>";
				else {
	
					$startDate = strtotime(sanitize('startYear') . "-" . sanitize('startMonth') . "-" . sanitize('startDate') . " " . (sanitize('startHour') + $startHourAdd) . ":" . sanitize('startMinute') . ":00");
					$endDate = strtotime(sanitize('endYear') . "-" . sanitize('endMonth') . "-" . sanitize('endDate') . " " . (sanitize('endHour') + $endHourAdd) . ":" . sanitize('endMinute') . ":00");
	
					if ($startDate > $endDate) {
	
						$tmpSave = $startDate;
						$startDate = $endDate;
						$endDate = $tmpSave;
							
					}
	
				}
	
				break;
	
			case "lastHour":
	
				$startDate = $currentTimeArray['0'] - 3600;
	
				break;
	
			case "last24Hours":
					
				$startDate = $currentTimeArray['0'] - 86400;
					
				break;
	
			case "today":
	
				$startDate = strtotime($currentTimeArray['year'] . "-" . $currentTimeArray['mon'] . "-" . $currentTimeArray['mday'] . " 00:00:00");
	
				break;
	
			case "thisWeek":
	
				$startDate = strtotime($currentTimeArray['year'] . "-" . $currentTimeArray['mon'] . "-" . $currentTimeArray['mday'] . " 00:00:00") - ($currentTimeArray['wday'] * 86400);
	
				break;
	
			case "thisMonth":
	
				$startDate = strtotime($currentTimeArray['year'] . "-" . $currentTimeArray['mon'] . "-01 00:00:00");
	
				break;
	
			case "lastWeek":
	
				$endDate = strtotime($currentTimeArray['year'] . "-" . $currentTimeArray['mon'] . "-" . $currentTimeArray['mday'] . " 00:00:00") - ($currentTimeArray['wday'] * 86400) - 1;
				$startDate = $endDate - 604799;
	
				break;
	
			case "lastMonth":
	
				$endDate = strtotime($currentTimeArray['year'] . "-" . $currentTimeArray['mon'] . "-01 00:00:00") - 1;
				$startDate = strtotime(date("Y-m",$endDate) . "-01 00:00:00");
	
				break;
	
		}
		//echo 'start date - timestamp: ' . $startDate . ', date: ' . date("Y-m-d H:i",$startDate) . '<br>';
		//echo 'end date - timestamp: ' . $endDate . ', date: ' . date("Y-m-d H:i",$endDate) . '<br>';
		if ($startDate)
			$dateQuery .= " AND evt.timestamp >= " . $startDate . " ";
	
		if ($endDate)
			$dateQuery .= " AND evt.timestamp <= " . $endDate . " ";
	
	}

	if (ops("site_custom_snortGroup") == 1) {

		// Custom Grouping Results
	
		$result = $_ENV['appDB']->query("SELECT count(mas.id) AS cnt, evt.$direction AS port FROM idsDataStore_" . $_SESSION["user"]["activeSearchStore"] . "_Master as mas LEFT JOIN idsDataStore_" . $_SESSION["user"]["activeSearchStore"] . "_Events as evt USING (id) where evt.customGrouping RLIKE REPLACE ( REPLACE ( REPLACE ('" . $_SESSION["user"]["sensors"] . "','+','[+]'), ' ', ''), ',', '|') AND evt.protocol = '$protocol' " . $dateQuery . "  group by evt.$direction order by cnt $order limit $num");

	} else {

		// Standard Results

		$result = $_ENV['appDB']->query("SELECT count(mas.id) AS cnt, evt.$direction AS port FROM idsDataStore_" . $_SESSION["user"]["activeSearchStore"] . "_Master as mas LEFT JOIN idsDataStore_" . $_SESSION["user"]["activeSearchStore"] . "_Events as evt USING (id) where mas.sensorID in (" . $_SESSION["user"]["sensors"] . ") AND evt.protocol = '$protocol' " . $dateQuery . "  group by evt.$direction order by cnt $order limit $num");
	
	}

	if ($result) {

		while ($row = mysql_fetch_assoc($result)) {

			$total += $row["cnt"];
			
			$resultArray[] = $row;
			
		}

		foreach ($resultArray as $data) {
		
			$data["percent"] = number_format($data["cnt"] / $total * 100, 2);
		
			if (count($chartArray) <= 10) {
			
				$chartArray[] = "{port: '" . str_replace("'","\'",htmlentities($data["port"])) . "', total: " . $data["cnt"] . "}";
				
			} else {
			
				$otherCount += $data["cnt"];
			
			}

			$out .= itemRenderer("frequentPorts", $data);
		
		}
		
		if ($otherCount) $chartArray[] = "{host: 'Other', total: " . $otherCount . "}";
		
	} else {
	
		$out .= "No data available";
	
	}

	if (!$out)
		$out = "No data available";

	return arrayToObject(array("table" => $out, "chart" => "var chartData = [" . implode(",", $chartArray) . "]","errorText" => $errorText));	
	
}

?>