<?php

function prv_geoLocationByIP() {

	// Accepts a single ip or comma delimited list of IP addresses

	$ipArray = explode(",", sanitize("ip"));

	$_ENV['contentTitle'] = "GeoLocation";

	$_ENV['templateData'] = geoLocationEventsByIP($ipArray);

	$_ENV['template'] = "template_geoLocation.php";

}

function poll_liveGeoLocation() {

	if (!getVar("id")) setVar("id", 0);
	if (!getVar("risk")) setVar("risk", 0);
	if (!getVar("num")) setVar("num", 10);

	$_ENV['contentTitle'] = "Live GeoLocation";

	$_ENV['templateData'] = liveGeoLocationEvents(sanitize("query"));
	
	$_ENV['template'] = "template_liveGeoLocationPoll.php";

}

function prv_liveGeoLocation() {

	if (!getVar("id")) setVar("id", 0);
	if (!getVar("risk")) setVar("risk", 0);
	if (!getVar("num")) setVar("num", 10);

	$_ENV['contentTitle'] = "Live GeoLocation";

	$queryArray[] = "recent:" . sanitize("num");
	if (sanitize("id")) $queryArray[] = "sensor:" . sanitize("id");
	if (sanitize("risk")) $queryArray[] = "risk:" . sanitize("risk");

	$query = implode(" ", $queryArray);

	$_ENV['contentTitle'] = "Live GeoLocation";
	
	$_ENV['templateData'] = liveGeoLocationEvents($query);

	$_ENV['template'] = "template_liveGeoLocation.php";

}

function displayLiveGeoLocationSensors() {

	// Sensor list

	$out .= itemRenderer("liveGeoLocationSensorSelection", array("id" => 0, "name" => "All Sensors"));

	$result = $_ENV['appDB']->query("SELECT * FROM idsSensor WHERE id IN (" . $_SESSION["user"]["sensors"] . ") AND enabled = 1 ORDER BY module, name");

	if ($result) {
	
		while ($row = mysql_fetch_assoc($result)) {
	
			if ($row["module"] == 1) {
			
				$row["moduleName"] = "Snort";
			
			} else if ($row["module"] == 2) {
	
				$row["moduleName"] = "Syslog";
			
			} else {
	
				$row["moduleName"] = "";
			
			}
	
			$out .= itemRenderer("liveGeoLocationSensorSelection", $row);
				
		}

	} else {
	
		$out = "No available sensors";
	
	}

	return $out;

}

function geoLocationEventsByIP($ipArray) {

	if ($ipArray) {

		$allDots = array();

		$ipArray = array_unique($ipArray);

		foreach ($ipArray as $ip) {

			// GeoLocation data
			
			// check if ip is in the no plot list
			$noPlot = noPlotTest($ip);
		
			if (!$noPlot) {

				$thisSource = buildJavascriptPlotsByIP(array($ip),5,"0.7","CC0000");
			
				if ($thisSource) {

					$allDots[] = $thisSource;
		
				} else {
			
					$message = "GeoLocation plot results not available for this address ($ip).";
			
				}

			} else {
		
				$message = "This address resides within the user defined No Plot list ($ip).";
		
			}
		
		}
		
		$allDots = array_unique($allDots);
		
		$mapDots = implode(",",$allDots);
		
		$_ENV['mapData'] = array("includeMap" => 1, "mapDots" => $mapDots);

	}

	// Delete old cache (if applicable)
	
	deleteOldGeoCache();

	$array = arrayToObject(array("message" => $message));
	
	return $array;

}

function liveGeoLocationEvents($query = "recent:25") {

	$risk = sanitize("risk");
	$num = sanitize("num");
	$sensor = sanitize("id");

	$tmpValues = explode(" ", $query);

	foreach ($tmpValues AS $thisQuery) {

		$tmpQueryValues = explode(":",$thisQuery);

		if ($tmpQueryValues[0] == "recent")
			$num = $tmpQueryValues[1];

		if ($tmpQueryValues[0] == "sensor")
			$sensor = $tmpQueryValues[1];

		if ($tmpQueryValues[0] == "risk")
			$risk = $tmpQueryValues[1];

	}

	if (!$sensor || ($sensor && $sensor == "0"))
		$sensor = $_SESSION["user"]["sensors"];

	unset($_ENV['mapData']);

	$trackArray = array();
	$eventArray = array();
	$allDots = array();
	$linesArray = array();

	$searchObj = new coreSearch();
	$searchObj->setVar("query", $query);
	$searchObj->setVar("store", ops("site_activeDataStore"));

	$result = $_ENV['appDB']->query("SELECT * FROM idsSensor WHERE id IN (" . $sensor . ") AND enabled = 1");

	if ($result) {

		while ($row = mysql_fetch_assoc($result)) {

			$sensorLocation = explode(",",$row["location"]);

			if ($sensorLocation[0] && $sensorLocation[1])
				$allDots[] = buildJavascriptPlots(array(array("title" => $row["name"],"longitude" => $sensorLocation[1], "latitude" => $sensorLocation[0])),5,"0.5","479CCF");

		}

	}

	$query =
		"SELECT s.id AS sensorID, e.sip, e.dip, s.location AS sensorLocation, s.name AS sensorName " .
		"FROM idsDataStore_" . ops("site_activeDataStore") . "_Events e " .
		"INNER JOIN idsSensor s " .
		"ON e.sensor = s.sid " .
		"WHERE s.module IN(1,2) " .
		"AND s.id in (" . $sensor . ") " .
		"AND (e.sip > 0 OR e.dip > 0) " .
		"AND s.enabled = 1 ";

	if ($risk)
		$query .= " AND e.priority = " . $risk;

	$query .= " ORDER BY e.timestamp DESC LIMIT " . $num;

	$result = $_ENV['appDB']->query($query);

	if ($result) {

		while ($row = mysql_fetch_assoc($result)) {

			$sensorLocation = explode(",",$row["sensorLocation"]);

			if ($sensorLocation[0] && $sensorLocation[1])
				$allDots[] = buildJavascriptPlots(array(array("title" => $row["sensorName"],"longitude" => $sensorLocation[1], "latitude" => $sensorLocation[0])),5,"0.5","479CCF");

			if (!noPlotTest($row["sip"])) {

				$thisSource = buildJavascriptPlotsByIP(array($row["sip"]),5,"0.5","CC0000");
				$allDots[] = $thisSource;

				$tmpLat = explode("latitude:",$thisSource);
				$tmpLat = explode(",",$tmpLat[1]);
				$tmpLat = $tmpLat[0];
				$tmpLong = explode("longitude:",$thisSource);
				$tmpLong = substr($tmpLong[1],0,-1);

				$linesArray[] = $sensorLocation[1] . "," . $sensorLocation[0];
				$linesArray[] = $tmpLong . "," . $tmpLat;

			}

			if (!noPlotTest($row["dip"])) {

				$thisDest = buildJavascriptPlotsByIP(array($row["dip"]),5,"0.5","000000");
				$allDots[] = $thisDest;

				$tmpLat = explode("latitude:",$thisDest);
				$tmpLat = explode(",",$tmpLat[1]);
				$tmpLat = $tmpLat[0];
				$tmpLong = explode("longitude:",$thisDest);
				$tmpLong = substr($tmpLong[1],0,-1);

				$linesArray[] = $sensorLocation[1] . "," . $sensorLocation[0];
				$linesArray[] = $tmpLong . "," . $tmpLat;

			}

		}

	}

	$allDots = array_unique($allDots);
	$mapLineLongs = array();
	$mapLineLats = array();

	foreach ($linesArray AS $thisFullLine) {

		$thisLine = explode(",",$thisFullLine);
		$mapLineLongs[] = $thisLine[0];
		$mapLineLats[] = $thisLine[1];

	}

	$mapDots = implode(",",$allDots);

	$_ENV['mapData'] = array("includeMap" => 1, "mapDots" => $mapDots, "mapLegend" => "{title:\"Sensor\", color:\"#479CCF\"}, {title:\"Source\", color:\"#CC0000\"}, {title:\"Destination\", color:\"#000000\"}", "mapLines" => "{latitudes:[" . implode(",",$mapLineLats) . "],longitudes:[" . implode(",",$mapLineLongs) . "]}");
	//$_ENV['mapData']['mapLines'] = "{latitudes:[39.76,38.0000,39.76,32.7110,39.76,,39.76,,39.76,32.7110,39.76,,39.76,,39.76,32.7110],longitudes:[-86.170526,-97.0000,-86.170526,-117.0535,-86.170526,,-6.170526,,-86.170526,-117.0535,-86.170526,,-86.170526,,-86.170526,-117.0535]}";
	deleteOldGeoCache();

	return;

	// Get event id's
	foreach ($searchObj->searchProcess() as $data) {

		$eventArray[] = $data;

	}

	// Process event id's
	
	foreach ($eventArray as $data) {

		// Event data

		$tmp = explode(":", $data);
		
		$store = $tmp[0];
		$eventID = $tmp[1];

		$searchObj->setVar("store", $store);

		$eventData = $searchObj->getDetailsByID(trim($eventID));

		// GeoLocation data
		
		// check if ip is in the no plot list
		$noPlot = noPlotTest($eventData["sip"]);
		
		if (!$noPlot) {
		
			$latLonArray = getLatLonCoordinates($eventData["sip"]);
			
			$lat = $latLonArray[0];
			$lon = $latLonArray[1];
			$city = $latLonArray[2];
			$state = $latLonArray[3];
			$country = $latLonArray[4];
			
			if ($lat) {

				if (!$trackArray["$lat,$lon"]) {
				
					// Sensor GeoLocation data
			
					$loc = trim(getLocationNameByID($eventData["sensorID"]));
					$loc = str_replace(" ", ",", $loc);
					$loc = explode(",", $loc);
				
					if ($lat == -27.0000 && $lon == 133.0000) {
					
						$sensorName = "Latitude & Longitude Not Configured for Sensor: " . getSensorNameByID($eventData["sensorID"]);
						
					} else {
					
						$sensorName = getSensorNameByID($eventData["sensorID"]);
					
					}
				
					$ms[$loc[0] . "," . $loc[1]] = "<movie lat=\"" . $loc[0] . "\" long=\"" . $loc[1] . "\" file=\"target\" width=\"15\" height=\"15\" color=\"#0000CC\" title=\"" . $sensorName . "\"></movie>";
				
					$ms["$lat,$lon"] = "<movie lat=\"$lat\" long=\"$lon\" file=\"target\" width=\"10\" height=\"10\" fixed_size=\"true\" color=\"#CC0000\" title=\"" . longToIP($eventData["sip"]) . " (" . doHostnameLookup(longToIP($eventData["sip"])) . ") $city, $state, $country\"></movie>";
				
				    $ls .= "<line lat=\"$lat, " . $loc[0] . "\" long=\"$lon, " . $loc[1] . "\" arrow=\"end\" width=\"1\" alpha=\"40\"></line>";
				
					$trackArray["$lat,$lon"] = 1;

				} else {

					$trackArray["$lat,$lon"]++;
					
					$size = 12 + ($trackArray["$lat,$lon"] * 2);

					$ms["$lat,$lon"] = "<movie lat=\"$lat\" long=\"$lon\" file=\"target\" width=\"$size\" height=\"$size\" fixed_size=\"true\" color=\"#CC0000\" title=\"" . longToIP($eventData["sip"]) . " (" . doHostnameLookup(longToIP($eventData["sip"])) . ") $city, $state, $country -- " . $trackArray["$lat,$lon"] . " Events\"></movie>";
				
				}
				
		
			}

		}

		// Delete old cache (if applicable)

		deleteOldGeoCache();
		
	}
	
	/*
	if (rand(0,1) == 1) {
		$scale = "1.5"; $color = "1C1C1C"; }
		else {
			$scale = "0.5"; $color = "FFFFFF"; }
	
			$mapDots = buildJavascriptPlotsByIP(array("209045022"),5,$scale,$color);
			$_ENV['mapData'] = array("includeMap" => 1,"mapDots" => $mapDots);
*/
	return "<lines>" . $ls . "</lines><movies>" . @implode(" ", $ms) . "</movies>";

}

function noPlotTest($longIP) {

	if (strstr($longIP, ".")) $longIP = ipToLong($longIP);

	$noPlotArray = explode(",", str_replace(" ", "", ops("site_geoLocationNoPlotList")));
	
	foreach ($noPlotArray as $net) {
	
		$tmp = explode("-", cidrconv($net));
		
		if ($longIP >= ipToLong($tmp[0]) && $longIP <= ipToLong($tmp[1])) {

			return true;

		}
	
	}
	
	return false;

}

function deleteOldGeoCache() {

	$cacheAgeLimit = time() - 604800;

	$_ENV['appDB']->query("DELETE FROM idsGeoCache WHERE timestamp < '$cacheAgeLimit' LIMIT 25");

}

function prv_downloadGeoDatabase() {

	ops("site_downloadGeoDatabaseNow", 1);
	
    // Redirect

    $_ENV['redirect'] = array("prv_main", 5000);
    
    $_ENV['redirectMessage'] = "Initiating Geo Database Download (may take some time)";

    $_ENV['template'] = "template_redirectGeneral.php";

}

?>